%Program for calculating S-sets (set for model CRRA-1)
load crra;
n=length(w);
zz=[ones(n-2,1) w(2:n-1)-mean(w(2:n-1)) r(2:n-1)-mean(r(2:n-1))];
k2=size(zz,2);
incs1=[0.6:0.005:1.1]';
incs2=[-6:0.5:60]';
for j=1:length(incs1);
for k=1:length(incs2);
beta=incs1(j); gamma=incs2(k);
v(j,k)=n*ex3liml([beta;gamma],w,r,zz)<chicv(k2);
end; end;

%Point estimates and VCOV matrix for conventional ellipse (from GAUSS program)%
est=[0.90277914; 0.13199661]; 
vcov=[0.00049846764 0.017366416; 0.017366416 1.0761763];
%These parameter values are for CRRA-1; need to be changed for other models
ht=ellipse(inv(vcov),chicv(k2)); 
ht(:,1)=ht(:,1)+est(1); ht(:,2)=ht(:,2)+est(2); 

g=[[1 1 1];[0.8 0.8 0.8]];
if sum(sum(v)')~=0;
pcolor(incs1,incs2,v');
end;
colormap(g)
xlabel('\delta')
ylabel('\gamma')
shading flat
axis([0.6 1.1 -6 60]);
line(ht(:,1),ht(:,2),'EraseMode','none','Linewidth',1,'Color','k');

